<template>
  <v-chart
    v-if="$q.platform.is.mobile"
    class="chart"
    :option="option"
    style="height: 85vh; width: 95%"
  />
  <v-chart
    v-else
    class="chart"
    :option="option"
    style="height: 95%; width: 95%"
  />
</template>

<script lang="ts">
import { defineComponent } from '@vue/composition-api';
import graph from './les-miserables.json';
import VChart, { THEME_KEY } from 'vue-echarts';
import { use } from 'echarts/core'
import { SVGRenderer  } from 'echarts/renderers';
import { GraphChart  } from 'echarts/charts';
import {
  TitleComponent,
  TooltipComponent,
  ToolboxComponent,
  VisualMapComponent,
  TimelineComponent,
  CalendarComponent,
  LegendComponent
} from 'echarts/components';

use ([
  SVGRenderer,
  GraphChart,
  TitleComponent,
  TooltipComponent,
  ToolboxComponent,
  VisualMapComponent,
  TimelineComponent,
  CalendarComponent,
  LegendComponent
])

export default defineComponent({
  name: 'IndexGraph',

  data () {
    return {
      option: {
        title: {
            text: 'Demo graph',
            subtext: 'Default layout',
            top: 'bottom',
            left: 'right'
        },
        // tooltip: {},
        legend: [{
            // selectedMode: 'single',
            data: graph.categories.map(function (a) {
                return a.name;
            })
        }],
        animationDuration: 1500,
        animationEasingUpdate: 'quinticInOut',
        series: [
            {
                name: 'Les Miserables',
                type: 'graph',
                layout: 'none',
                data: graph.nodes,
                links: graph.links,
                categories: graph.categories,
                roam: true,
                // label: {
                //     position: 'right',
                //     formatter: '{b}'
                // },
                label: false,
                lineStyle: {
                    color: 'source',
                    curveness: 0.3
                },
                emphasis: {
                    focus: 'adjacency',
                    lineStyle: {
                        width: 10
                    }
                }
            }
        ]
    }
    }
  },

  components: { VChart },

  provide: {
    [THEME_KEY]: 'dark'
  }
})
</script>
